# all files / ol/source/ tilearcgisrest.js

94.92% Statements 56/59
66.67% Branches 12/18
85.71% Functions 6/7
94.92% Lines 56/59

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    1841×

    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    17×

    17×

    17×

    17×

    17×

    1×

    1×
    21×
    21×
    21×
    13×

    21×

    1×
    3×

    1×

    10×
    10×

    10×

    10×
    10×
    10×
    10×
    10×

    10×
    10×
    9×

    1×
    1×

    10×

    10×

    1×

    1×

    10×
    10×
    10×

    10×

    10×

    10×

    10×
    2×

    10×

    10×

    10×

    1×
    4×
    4×

     goog.provide('ol.source.TileArcGISRest');

    goog.require('ol');
    goog.require('ol.extent');
    goog.require('ol.math');
    goog.require('ol.obj');
    goog.require('ol.size');
    goog.require('ol.source.TileImage');
    goog.require('ol.tilecoord');
    goog.require('ol.uri');

    /**
     * @classdesc
     * Layer source for tile data from ArcGIS Rest services. Map and Image
     * Services are supported.
     *
     * For cached ArcGIS services, better performance is available using the
     * {@link ol.source.XYZ} data source.
     *
     * @constructor
     * @extends {ol.source.TileImage}
     * @param {olx.source.TileArcGISRestOptions=} opt_options Tile ArcGIS Rest
     *     options.
     * @api
     */
    ol.source.TileArcGISRest = function(opt_options) {

      var options = opt_options || {};

      ol.source.TileImage.call(this, {
        attributions: options.attributions,
        cacheSize: options.cacheSize,
        crossOrigin: options.crossOrigin,
        logo: options.logo,
        projection: options.projection,
        reprojectionErrorThreshold: options.reprojectionErrorThreshold,
        tileGrid: options.tileGrid,
        tileLoadFunction: options.tileLoadFunction,
        url: options.url,
        urls: options.urls,
        wrapX: options.wrapX !== undefined ? options.wrapX : true
      });

      /**
       * @private
       * @type {!Object}
       */
      this.params_ = options.params || {};

      /**
       * @private
       * @type {ol.Extent}
       */
      this.tmpExtent_ = ol.extent.createEmpty();

      this.setKey(this.getKeyForParams_());
    };
    ol.inherits(ol.source.TileArcGISRest, ol.source.TileImage);

    /**
     * @private
     * @return {string} The key for the current params.
     */
    ol.source.TileArcGISRest.prototype.getKeyForParams_ = function() {
      var i = 0;
      var res = [];
      for (var key in this.params_) {
        res[i++] = key + '-' + this.params_[key];
      }
      return res.join('/');
    };

    /**
     * Get the user-provided params, i.e. those passed to the constructor through
     * the "params" option, and possibly updated using the updateParams method.
     * @return {Object} Params.
     * @api
     */
    ol.source.TileArcGISRest.prototype.getParams = function() {
      return this.params_;
    };

    /**
     * @param {ol.TileCoord} tileCoord Tile coordinate.
     * @param {ol.Size} tileSize Tile size.
     * @param {ol.Extent} tileExtent Tile extent.
     * @param {number} pixelRatio Pixel ratio.
     * @param {ol.proj.Projection} projection Projection.
     * @param {Object} params Params.
     * @return {string|undefined} Request URL.
     * @private
     */
    ol.source.TileArcGISRest.prototype.getRequestUrl_ = function(tileCoord, tileSize, tileExtent,
        pixelRatio, projection, params) {

      var urls = this.urls;
      Iif (!urls) {
        return undefined;
      }

      // ArcGIS Server only wants the numeric portion of the projection ID.
      var srid = projection.getCode().split(':').pop();

      params['SIZE'] = tileSize[0] + ',' + tileSize[1];
      params['BBOX'] = tileExtent.join(',');
      params['BBOXSR'] = srid;
      params['IMAGESR'] = srid;
      params['DPI'] = Math.round(
          params['DPI'] ? params['DPI'] * pixelRatio : 90 * pixelRatio
      );

      var url;
      if (urls.length == 1) {
        url = urls[0];
      } else {
        var index = ol.math.modulo(ol.tilecoord.hash(tileCoord), urls.length);
        url = urls[index];
      }

      var modifiedUrl = url
          .replace(/MapServer\/?$/, 'MapServer/export')
          .replace(/ImageServer\/?$/, 'ImageServer/exportImage');
      return ol.uri.appendParams(modifiedUrl, params);
    };

    /**
     * @inheritDoc
     */
    ol.source.TileArcGISRest.prototype.getTilePixelRatio = function(pixelRatio) {
      return /** @type {number} */ (pixelRatio);
    };

    /**
     * @inheritDoc
     */
    ol.source.TileArcGISRest.prototype.fixedTileUrlFunction = function(tileCoord, pixelRatio, projection) {

      var tileGrid = this.getTileGrid();
      Eif (!tileGrid) {
        tileGrid = this.getTileGridForProjection(projection);
      }

      Iif (tileGrid.getResolutions().length <= tileCoord[0]) {
        return undefined;
      }

      var tileExtent = tileGrid.getTileCoordExtent(
          tileCoord, this.tmpExtent_);
      var tileSize = ol.size.toSize(
          tileGrid.getTileSize(tileCoord[0]), this.tmpSize);

      if (pixelRatio != 1) {
        tileSize = ol.size.scale(tileSize, pixelRatio, this.tmpSize);
      }

      // Apply default params and override with user specified values.
      var baseParams = {
        'F': 'image',
        'FORMAT': 'PNG32',
        'TRANSPARENT': true
      };
      ol.obj.assign(baseParams, this.params_);

      return this.getRequestUrl_(tileCoord, tileSize, tileExtent,
          pixelRatio, projection, baseParams);
    };

    /**
     * Update the user-provided params.
     * @param {Object} params Params.
     * @api
     */
    ol.source.TileArcGISRest.prototype.updateParams = function(params) {
      ol.obj.assign(this.params_, params);
      this.setKey(this.getKeyForParams_());
    };